#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <economy>

#undef REQUIRE_PLUGIN
#include <ToggleEffects>

enum Hat
{
	String:Name[64],
	String:ModelPath[256], 
	Float:Position[3],
	Float:Angles[3],
	String:Flag[2],
	String:Description[64],
	String:Id[64],
	Price
}

enum HatClassSettings
{
	String:HatName[64],
	String:ModelPath[256],
	Float:Position[3],
	Float:Angles[3]
}

new Handle:g_hLookupAttachment = INVALID_HANDLE;

new bool:toggleEffects = false;
new bool:zombiereloaded = false;
new bool:zombieriot = false;

new hats[1024][Hat];
new hatCount = 0;

new classes[1024][HatClassSettings];
new classCount = 0;

new g_iHats[MAXPLAYERS+1]={0,...};

public Plugin:myinfo =
{
    name        = "Hats",
    author      = "alongub",
    description = "Hats",
    version     = "1.0.0",
    url         = "http://steamcommunity.com/id/alon"
};

public OnMapStart()
{
	LoadHats();
}

public OnPluginStart()
{
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("player_death", Event_PlayerDeath);
	
	toggleEffects = LibraryExists("ToggleEffects");
	zombiereloaded = LibraryExists("zombiereloaded");
	zombieriot = LibraryExists("zombieriot");

	new Handle:hGameConf = LoadGameConfigFile("hats.gamedata");
	StartPrepSDKCall(SDKCall_Entity);
	PrepSDKCall_SetFromConf(hGameConf, SDKConf_Signature, "LookupAttachment");
	PrepSDKCall_SetReturnInfo(SDKType_PlainOldData, SDKPass_Plain);
	PrepSDKCall_AddParameter(SDKType_String, SDKPass_Pointer);
	g_hLookupAttachment = EndPrepSDKCall();
}

public OnLibraryAdded(const String:name[])
{
	if (StrEqual(name, "zombiereloaded"))
	{
		zombiereloaded = true;
	}
	else if (StrEqual(name, "zombieriot"))
	{
		zombieriot = true;
	}
}

public OnLibraryRemoved(const String:name[])
{
	if (StrEqual(name, "zombiereloaded"))
	{
		zombiereloaded = false;
	}
	else if (StrEqual(name, "zombieriot"))
	{
		zombieriot = false;
	}
}

public LoadHats()
{	
	Economy_RegisterItemCategory("hats", "Hats", "Hats are the meaning of life. Buy them now.");
  
	new String:sConfig[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, sConfig, PLATFORM_MAX_PATH, "configs/store/hats.txt");
	
	new Handle:kv = CreateKeyValues("Hats");
	FileToKeyValues(kv, sConfig);
	
	new Float:temp[3];
		
	if(KvGotoFirstSubKey(kv))
	{
		do
		{
			KvGetSectionName(kv, hats[hatCount][Name], 64);

			KvGetString(kv, "description", hats[hatCount][Description], 64);
			KvGetString(kv, "id", hats[hatCount][Id], 64);
			KvGetString(kv, "model", hats[hatCount][ModelPath], 256);
			KvGetString(kv, "flag", hats[hatCount][Flag], 2);
			
			KvGetVector(kv, "position", temp);
			hats[hatCount][Position] = temp;
			
			KvGetVector(kv, "angles", temp);
			hats[hatCount][Angles] = temp;
			
			hats[hatCount][Price] = KvGetNum(kv, "price"); 			
		
			if(strcmp(hats[hatCount][ModelPath], "") != 0 && (FileExists(hats[hatCount][ModelPath]) || FileExists(hats[hatCount][ModelPath], true)))
			{
				// TODO: Add to download table
				PrecacheModel(hats[hatCount][ModelPath], true);
			}
      		
			if (KvJumpToKey(kv, "classes"))
			{
				new Handle:classesKv = CreateKeyValues("classes");
				KvCopySubkeys(kv, classesKv);

				KvGotoFirstSubKey(classesKv);
				
				do
				{
					KvGetSectionName(classesKv, classes[classCount][ModelPath], 255);
					strcopy(classes[classCount][HatName], 64, hats[hatCount][Name]);

					KvGetVector(classesKv, "position", temp);
					classes[classCount][Position] = temp;

					KvGetVector(classesKv, "angles", temp);
					classes[classCount][Angles] = temp;

					classCount++;
				} while (KvGotoNextKey(classesKv));

				KvGoBack(kv);
				CloseHandle(classesKv);
      		}
      			
			Economy_RegisterItem("hats", hats[hatCount][Id], hats[hatCount][Name], hats[hatCount][Description], OnEquipItem, hats[hatCount][Price], false, true, true, true);
			
			hatCount++;
		} while (KvGotoNextKey(kv));
	}
	
	CloseHandle(kv);
}

public OnEquipItem(client, String:id[])
{
	if (Economy_IsToggled(client, id))
	{
		Economy_ToggleItem(client, id, false);
		DequipHat(client);
		
		PrintToChat(client, "You have dequipped the hat.");
	}
	else
	{
		Economy_ToggleItemCategory(client, "hats", false);
		Economy_ToggleItem(client, id, true);	
		
		EquipHat(client);
				
		PrintToChat(client, "You have equipped the hat.");
	}
}

EquipHat(client)
{
    PrintToConsole(client, "EquipHat Start");
    
	if (!IsClientInGame(client))
		return;
	
    PrintToConsole(client, "Client in game");
    
	if (!IsPlayerAlive(client))
		return;
	
    PrintToConsole(client, "Client Alive, Calling DequipHat");

	DequipHat(client);
	
    PrintToConsole(client, "Checking if the server has zombie plugin");
    
	if (zombiereloaded)
		if (!ZR_IsClientHuman(client))
			return;
	
	if (zombieriot)
		if (ZRiot_IsClientZombie(client))
			return;
            
	PrintToConsole(client, "No.");
    
	if (!LookupAttachment(client, "forward")) 
		return;
        
	PrintToConsole(client, "The client model has the forward attachment");
    
	new String:itemId[64];
	if (!Economy_GetPrimaryToggled(client, "hats", itemId))
    {
        PrintToConsole(client, "Economy_GetPrimaryToggled returned false, exiting");
		return;
    }
    
	PrintToConsole(client, "Economy_GetPrimaryToggled returned true");
    
	new hat = -1;

	for (new i = 0; i < hatCount; i++)
	{
		if (StrEqual(itemId, hats[i][Id]))
		{
			hat = i;
			break;
		}
	}

    PrintToConsole(client, "Hat: %d", hat);
    
	if (hat == -1)
		return;

	new Float:or[3];
	new Float:ang[3];
	new Float:fForward[3];
	new Float:fRight[3];
	new Float:fUp[3];
	
	GetClientAbsOrigin(client,or);
	GetClientAbsAngles(client,ang);

	new String:clientModel[256];
	GetClientModel(client, clientModel, sizeof(clientModel));

	new class = -1;

	for (new j = 0; j < classCount; j++)
	{
		if (StrEqual(hats[hat][HatName], classes[j][HatName]) && StrEqual(clientModel, classes[j][ModelPath], false))
		{
			class = j;
			break;
		}
	}
    
    PrintToConsole(client, "Class: %d", class);
    
	if (class == -1)
	{
		ang[0] += hats[hat][Angles][0];
		ang[1] += hats[hat][Angles][1];
		ang[2] += hats[hat][Angles][2];
	}
	else
	{
		ang[0] += classes[class][Angles][0];
		ang[1] += classes[class][Angles][1];
		ang[2] += classes[class][Angles][2];		
	}


	new Float:fOffset[3];

	if (class == -1)
	{
		fOffset[0] = hats[hat][Position][0];
		fOffset[1] = hats[hat][Position][1];
		fOffset[2] = hats[hat][Position][2];	
	}
	else
	{
		fOffset[0] = classes[class][Position][0];
		fOffset[1] = classes[class][Position][1];
		fOffset[2] = classes[class][Position][2];		
	}	

		
	GetAngleVectors(ang, fForward, fRight, fUp);

	or[0] += fRight[0]*fOffset[0]+fForward[0]*fOffset[1]+fUp[0]*fOffset[2];
	or[1] += fRight[1]*fOffset[0]+fForward[1]*fOffset[1]+fUp[1]*fOffset[2];
	or[2] += fRight[2]*fOffset[0]+fForward[2]*fOffset[1]+fUp[2]*fOffset[2];

    PrintToConsole(client, "Creating entity, model: %s", hats[hat][ModelPath]);
    
	new ent = CreateEntityByName("prop_dynamic_override");
	DispatchKeyValue(ent, "model", hats[hat][ModelPath]);
	DispatchKeyValue(ent, "spawnflags", "256");
	DispatchKeyValue(ent, "solid", "0");
	SetEntPropEnt(ent, Prop_Send, "m_hOwnerEntity", client);
	
	DispatchSpawn(ent);	
	AcceptEntityInput(ent, "TurnOn", ent, ent, 0);
	
	g_iHats[client] = ent;
	
	SDKHook(ent, SDKHook_SetTransmit, ShouldHide);
	
	TeleportEntity(ent, or, ang, NULL_VECTOR); 
	
	SetVariantString("!activator");
	AcceptEntityInput(ent, "SetParent", client, ent, 0);
	
	SetVariantString("forward");
	AcceptEntityInput(ent, "SetParentAttachmentMaintainOffset", ent, ent, 0);
    
    PrintToConsole(client, "End.");
}

DequipHat(client)
{  
    PrintToConsole(client, "DequipHat Start");
    
	if(g_iHats[client] != 0 && IsValidEdict(g_iHats[client]))
	{
        PrintToConsole(client, "There was a hat");
        
		SDKUnhook(g_iHats[client], SDKHook_SetTransmit, ShouldHide);
		AcceptEntityInput(g_iHats[client], "Kill");
        
        PrintToConsole(client, "Killed");
	}
	
	g_iHats[client] = 0;
    PrintToConsole(client, "EquipHat End");
}

public Action:ShouldHide(ent, client)
{
	if(toggleEffects && !ShowClientEffects(client))
		return Plugin_Handled;

	if(ent == g_iHats[client])
		return Plugin_Handled;

	if (IsClientInGame(client) && IsValidEdict(client))
		if(GetEntProp(client, Prop_Send, "m_iObserverMode") == 4 && GetEntPropEnt(client, Prop_Send, "m_hObserverTarget") >= 0)
			if(ent == g_iHats[GetEntPropEnt(client, Prop_Send, "m_hObserverTarget")])
				return Plugin_Handled;
	
	return Plugin_Continue;
}

public Action:Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	CreateTimer(1.0, SpawnTimer, client);
	
	return Plugin_Continue;
}

public Action:SpawnTimer(Handle:timer, any:client)
{
	EquipHat(client);
}


public Action:Event_PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	DequipHat(client);
	
	return Plugin_Continue;
}

public ZR_OnClientInfected(client, attacker, bool:motherInfect, bool:respawnOverride, bool:respawn)
{
	DequipHat(client);
}

stock LookupAttachment(client, String:point[])
{
    if(g_hLookupAttachment==INVALID_HANDLE) return 0;
    if(client<=0 || !IsClientInGame(client)) return 0;
	
    return SDKCall(g_hLookupAttachment, client, point);
}