#include <sourcemod>
#include <loghelper>
#include <economy>

new Handle:g_timer = INVALID_HANDLE;

new Handle:g_hInterval;
new Handle:g_hMoneyPerTick;

public Plugin:myinfo =
{
    name        = "[Economy] Money Distributor",
    author      = "alongub",
    description = "Money Distributor component for [Economy]",
    version     = PL_VERSION,
    url         = "http://steamcommunity.com/id/alon"
};

public OnPluginStart() 
{
	g_hInterval = CreateConVar("eco_distributor_interval", "60", "The interval you get credits.");
	g_hMoneyPerTick = CreateConVar("eco_distributor_moneypertick", "5", "Amount of credits all players get every time.");	
	
	AutoExecConfig(true);
}

public OnConfigsExecuted() 
{
    if (g_timer != INVALID_HANDLE)
    {
        CloseHandle(g_timer);
    }
    
	g_timer = CreateTimer(GetConVarFloat(g_hInterval), ForgivePoints, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
}

public Action:ForgivePoints(Handle:timer)
{
	GiveMoneyToAllPlayers(GetConVarInt(g_hMoneyPerTick));
}

GiveMoneyToAllPlayers(amount)
{
	for (new client = 1; client <= MaxClients; client++)
	{
		if (IsValidPlayer(client) && !IsClientObserver(client))
		{
			Economy_GivePlayerMoney(client, -1, amount);
			PrintToChat(client, "You have received %d credits. You can open !store to use them.", amount);			
		}
	}
}