#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <economy>

#undef REQUIRE_PLUGIN
#include <zombiereloaded>
#include <zriot>

new bool:zombiereloaded = false;
new bool:zombieriot = false;

stock const String:PrimarySprites[][] = 
{ 
	"decals/concrete/SHOT1_paint.vmt", // 0 - red
	"decals/concrete/SHOT2_paint.vmt", // 1 - blue
	"decals/concrete/SHOT3_paint.vmt", // 2 - green
	"decals/concrete/SHOT5_paint.vmt" // 3 - yellow
};

new g_LastButtons[MAXPLAYERS+1];

new String:gSpriteIndex[sizeof PrimarySprites];

stock const String:SecondarySprites[][] =
{
	"decals/concrete/SHOT1_paint.vtf",
	"decals/concrete/SHOT1norm_paint.vtf",
	"decals/concrete/SHOT2_paint.vtf", 
	"decals/concrete/SHOT2norm_paint.vtf", 
	"decals/concrete/SHOT3_paint.vtf",
	"decals/concrete/SHOT3norm_paint.vtf",
	"decals/concrete/SHOT5_paint.vtf",
	"decals/concrete/SHOT5norm_paint.vtf"
};

new g_clientsPaintballEnabled[MAXPLAYERS+1];

public Plugin:myinfo =
{
	name		= "Paintball",
	author		= "alongub",
	description = "Paintball",
	version		= "1.0.0",
	url			 = "http://steamcommunity.com/id/alon"
};

public OnPluginStart()
{
	zombiereloaded = LibraryExists("zombiereloaded");
	zombieriot = LibraryExists("zombieriot");

	HookEvent("round_start", Event_RoundStart);
	HookEvent("bullet_impact", Event_BulletImpact);	
}

public OnLibraryAdded(const String:name[])
{
	if (StrEqual(name, "zombiereloaded"))
	{
		zombiereloaded = true;
	}
	else if (StrEqual(name, "zombieriot"))
	{
		zombieriot = true;
	}
}

public OnLibraryRemoved(const String:name[])
{
	if (StrEqual(name, "zombiereloaded"))
	{
		zombiereloaded = false;
	}
	else if (StrEqual(name, "zombieriot"))
	{
		zombieriot = false;
	}
}

public OnMapStart()
{
	Economy_RegisterItem("tools", "paintball", "Paintball", "Adds paint to bullet impacts.", OnPaintballUsed, 3000, true, false, true, true);

 	static String:PrimaryDecals[256], String:SecondaryDecals[256];
	
	for(new i = 0 ; i < sizeof(PrimarySprites); i++)
	{
		gSpriteIndex[i] = PrecacheModel(PrimarySprites[i]);
		
		Format(PrimaryDecals,sizeof(PrimaryDecals),"materials/%s",PrimarySprites[i]);
		AddFileToDownloadsTable(PrimaryDecals);
	}
	
	for(new j = 0; j < sizeof(SecondarySprites); j++)
	{
		PrecacheModel(SecondarySprites[j]);
		
		Format(SecondaryDecals,sizeof(SecondaryDecals),"materials/%s",SecondarySprites[j]);
		AddFileToDownloadsTable(SecondaryDecals);
	}	
}

public OnPaintballUsed(client, String:id[])
{
	if ((zombiereloaded && !ZR_IsClientHuman(client)) || (zombieriot && !ZRiot_IsClientZombie(client)))
	{
		PrintToChat(client, "You can't use paintball as a zombie.");
		return false;
	}
	
	g_clientsPaintballEnabled[client] = true;
	return true;
}

public Action:Event_RoundStart(Handle:event, const String:weaponName[], bool:dontBroadcast)
{
	for (new i = 0; i < MAXPLAYERS+1; i++)
	{
		g_clientsPaintballEnabled[i] = false;
	}
}

public Action:Event_BulletImpact(Handle:event, const String:weaponName[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
 	if(client <= 0 || !IsClientInGame(client))
		return;
 
	if (g_clientsPaintballEnabled[client])
	{
		static Float:fAimOrigin[3];

		if(GetAimOrigin(client, fAimOrigin))
		{
			if(TR_GetPointContents(fAimOrigin) == CONTENTS_WATER)
				return;
		
			TE_SetupGlowSprite(fAimOrigin, gSpriteIndex[GetRandomInt(0,sizeof(PrimarySprites)-1)], 300.0, 0.2, 200);
			TE_SendToAll();
		}
	}
}

stock GetAimOrigin(client, Float:hOrigin[3]) 
{
	new Float:vAngles[3], Float:fOrigin[3];
	GetClientEyePosition(client,fOrigin);
	GetClientEyeAngles(client, vAngles);

	new Handle:trace = TR_TraceRayFilterEx(fOrigin, vAngles, MASK_SOLID, RayType_Infinite, TraceEntityFilterPlayer);

	if(TR_DidHit(trace)) 
	{
		TR_GetEndPosition(hOrigin, trace);
		
		new entity = TR_GetEntityIndex(trace);
		
		if(!IsValidEdict(entity))
		{
			CloseHandle(trace);
			return 0;
		}
					
		CloseHandle(trace);
		return 1;
	}

	CloseHandle(trace);
	return 0;
}

public bool:TraceEntityFilterPlayer(entity, contentsMask) 
{
 	return entity > GetMaxClients();
}