#include <sourcemod>
#include <sdktools>
#include <economy>

enum Skin
{
	String:Name[64],
	String:ModelPath[256], 
	String:Description[64],
	String:Id[64],
	Price,
	Team
}

new bool:skinsLoaded = false;

new skins[1024][Skin];
new skinCount = 0;

public Plugin:myinfo =
{
    name        = "Skins",
    author      = "alongub",
    description = "Skins",
    version     = "1.0.0",
    url         = "http://steamcommunity.com/id/alon"
};

public OnPluginStart()
{
	HookEvent("player_spawn", Event_PlayerSpawn);
    
    skinsLoaded = false;
	LoadSkins();    
}

public OnMapStart()
{
    skinsLoaded = false;
	LoadSkins();
}

public Action:Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	CreateTimer(1.5, Timer_Spawn, client);
	
	return Plugin_Continue;
}

public Action:Timer_Spawn(Handle:timer, any:client)
{
    if (!skinsLoaded)
        return Plugin_Continue;
        
	if (GetClientTeam(client) == 2)
	{
		new String:itemId[64];
		if (!Economy_GetPrimaryToggled(client, "skins_t", itemId))
			return Plugin_Continue;
			
		new skin = -1;

		for (new i = 0; i < skinCount; i++)
		{
			if (StrEqual(itemId, skins[i][Id]))
			{
				skin = i;
			}
		}
		
		if (skin != -1)		
			SetEntityModel(client, skins[skin][ModelPath]);
	}
	else if (GetClientTeam(client) == 3)
	{
		new String:itemId[64];
		if (!Economy_GetPrimaryToggled(client, "skins_ct", itemId))
			return Plugin_Continue;
			
		new skin = -1;

		for (new i = 0; i < skinCount; i++)
		{
			if (StrEqual(itemId, skins[i][Id]))
			{
				skin = i;
			}
		}
		
		if (skin != -1)		
			SetEntityModel(client, skins[skin][ModelPath]);	
	}

}

public LoadSkins()
{	
	Economy_RegisterItemCategory("skins_t", "Skins (T)", "");
 	Economy_RegisterItemCategory("skins_ct", "Skins (CT)", "");
	
	new String:sConfig[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, sConfig, PLATFORM_MAX_PATH, "configs/store/skins.txt");
	
	new Handle:kv = CreateKeyValues("Skins");
	FileToKeyValues(kv, sConfig);
		
	if(KvGotoFirstSubKey(kv))
	{
		do
		{
			KvGetSectionName(kv, skins[skinCount][Name], 64);

			KvGetString(kv, "description", skins[skinCount][Description], 64);
			KvGetString(kv, "id", skins[skinCount][Id], 64);
			KvGetString(kv, "model", skins[skinCount][ModelPath], 256);
			
			skins[skinCount][Price] = KvGetNum(kv, "price"); 			
			skins[skinCount][Team] = KvGetNum(kv, "team"); 
			
			if(strcmp(skins[skinCount][ModelPath], "") != 0 && (FileExists(skins[skinCount][ModelPath]) || FileExists(skins[skinCount][ModelPath], true)))
			{
				// TODO: Add to download table
				// PrecacheModel(skins[skinCount][ModelPath], true);
			}
      		
			if (skins[skinCount][Team] == 2)
				Economy_RegisterItem("skins_t", skins[skinCount][Id], skins[skinCount][Name], skins[skinCount][Description], OnEquipItem_T, skins[skinCount][Price], false, true, true, true);
			else if (skins[skinCount][Team] == 3)
				Economy_RegisterItem("skins_ct", skins[skinCount][Id], skins[skinCount][Name], skins[skinCount][Description], OnEquipItem_CT, skins[skinCount][Price], false, true, true, true);
				
			skinCount++;
		} while (KvGotoNextKey(kv));
	}
	
	CloseHandle(kv);
    skinsLoaded = true;
}

public OnEquipItem_T(client, String:id[])
{
	if (Economy_IsToggled(client, id))
	{
		Economy_ToggleItem(client, id, false);
		PrintToChat(client, "You have removed the skin.");
	}
	else
	{
		Economy_ToggleItemCategory(client, "skins_t", false);
		Economy_ToggleItem(client, id, true);	

		PrintToChat(client, "You have selected the skin. It will change in the next round.");
	}
}

public OnEquipItem_CT(client, String:id[])
{
	if (Economy_IsToggled(client, id))
	{
		Economy_ToggleItem(client, id, false);
		PrintToChat(client, "You have removed the skin.");
	}
	else
	{
		Economy_ToggleItemCategory(client, "skins_ct", false);
		Economy_ToggleItem(client, id, true);	

		PrintToChat(client, "You have selected the skin. It will change in the next round.");
	}
}


